--------------------------------------------------------------------------------
-- EETAC - CSD - P8 - http://digsys.upc.edu
--------------------------------------------------------------------------------
-- Example of FSM to control the datapath of a programmable timer 
-- FSM design style 
-- https://digsys.upc.edu/csd/exams/D2_21/D2_21.html
--------------------------------------------------------------------------------
LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;
USE  IEEE.STD_LOGIC_UNSIGNED.all;
			
ENTITY Timer_FSM IS
   Port (
	CLK, CD       			: IN	STD_LOGIC;
    Trigger	    			: IN	STD_LOGIC;  
    Terminal_Count			: IN	STD_LOGIC;      
    LD_time, LD_Counter 	: OUT	STD_LOGIC; 
	CNT_enable				: OUT	STD_LOGIC; 
    Timer_OUT, Timer_Flag	: OUT	STD_LOGIC
	);
END Timer_FSM;

-- Internal desciption in FSM style
--------------------------------------------------------------------------------
ARCHITECTURE synch_FSM OF Timer_FSM IS
BEGIN

END synch_FSM;






