--------------------------------------------------------------------------------
-- EETAC - CSD - P7 - http://digsys.upc.edu
--------------------------------------------------------------------------------
-- Reversible synchronous counter modulo 256 (8-bit). 
-- FSM design style (plan B)
-- This FSM VHDL schematic code is adapted from tutorials listed in P7 
-- learning materials 
--------------------------------------------------------------------------------

LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;
USE  IEEE.STD_LOGIC_ARITH.all;
USE  IEEE.STD_LOGIC_UNSIGNED.all;

ENTITY counter_8bit IS
      Port (	
		CLK   			: IN	STD_LOGIC;
		CD 	  			: IN	STD_LOGIC;
		LD, CE, UD_L	: IN	STD_LOGIC;			
		D_in  			: IN	STD_LOGIC_VECTOR(7 DOWNTO 0);
		Q	  			: OUT	STD_LOGIC_VECTOR(7 DOWNTO 0);
		TC256  			: OUT	STD_LOGIC
          	);       
		          	
END counter_8bit;

			-- Internal desciption in FSM style

ARCHITECTURE FSM_like OF counter_8bit IS
BEGIN

END FSM_like;





